/*!	@file
	@brief Resource Database

	@author wakura
	@date 2008
*/
/*
	Copyright (C) 2008, wakura

	This software is provided 'as-is', without any express or implied
	warranty. In no event will the authors be held liable for any damages
	arising from the use of this software.

	Permission is granted to anyone to use this software for any purpose, 
	including commercial applications, and to alter it and redistribute it 
	freely, subject to the following restrictions:

		1. The origin of this software must not be misrepresented;
		   you must not claim that you wrote the original software.
		   If you use this software in a product, an acknowledgment
		   in the product documentation would be appreciated but is
		   not required.

		2. Altered source versions must be plainly marked as such, 
		   and must not be misrepresented as being the original software.

		3. This notice may not be removed or altered from any source
		   distribution.
*/
#ifndef CRCDB_H
#define CRCDB_H

/*
	LCID:
		http://www.microsoft.com/globaldev/reference/lcid-all.mspx

	sakura_rc_1033.dllvWFNg̍쐬
		̃t@Csakura_rc_1033tH_ɃRs[܂B
			sakura_rc.rc
			sakura_rc.h
			sakura_rc.hm
			funccode.h
		sakura_rc.rcDialog,String,VersionuRs[}vŖړǏɃRs[܂B
			Rs[̌ł͕svȂ̂ō폜܂B
			ʓ|ȂGfB^ŒڕҏWĂB
	
	\[X̕ҏW
		sakura_rc.rcҏWăbZ[WړǏɏ܂B
		F_̋@\ɊւĂ͎̂悤ɂȂ܂B
			: "Name,Enable,Disable,EnableSC,DisableSC"
				Name: @\iݒʂŎg܂j
				Enable: EnablêƂɕ\郁j[
				Disable: DisablêƂɕ\郁j[
				EnableSC: EnablêƂɕ\郁j[iV[gJbgL[ォ疄ߍށj
				DisableSC: DisablêƂɕ\郁j[iV[gJbgL[ォ疄ߍށj
		Enable/Disable,ToggleɑΉ邽߁Aj[ɂăV[gJbgL[ωꍇɑΉ邽߂łB
		j[ŎgȂ"Name,Enable,,,"̂悤ɏ܂B
		PȂ镶ƂĎgƂ"Name"̂悤ɏ܂B

	bZ[W̕ҏW
		RcDbMessages.mcɃbZ[WǉEҏWĂB

	̑̕
		bZ[W̕iƂĎgꍇ́AbZ[Wɒǉ܂B
		̑̕iƂĎgꍇ́A\[Xɒǉ܂B
		iɌ܂͂܂j

	mc.exeJX^rh̐ݒ
		fmtmsg/RcDbMessages.mcvWFNgɒǉ܂B
		RcDbMessages.mcENbNvpeB\܂B
		JX^rhXebvɎ̏ݒ肵܂B
			R}hC: mc.exe -v -A "$(InputDir)\$(InputName).mc" -r $(InputDir) -h $(InputDir)
			o̓t@C: $(InputDir)\$(InputName).rc;$(InputDir)\$(InputName).h
		pXɋ󔒂܂߂邱Ƃł܂I(-r,-hIvV""ŊȂ)

	bZ[W\[X̃CN[hݒ
		fmtmsg/RcDbMessages_1033.rcpӂ܂B(1033͖ړǏID)
			RcDbMessages.mcRpCƂɂłRcDbMessages.rcړǏ񂾂ĉłB
		sakura_rc_1033sakura_rc.rcENbN\[Xt@C̃CN[h\܂B
		RpCɒǉt@CɎ̏ݒ肵܂B(1033͖ړǏID)
			#include "fmtmsg/RcDbMessages_1033.rc"

	bZ[W𗘗pꍇfmtmsg/CN[htH_ɒǉݒ肵܂B
		邢 #include "fmtmsg/RcDbMessages.h" ̂悤Ɏw肵Ă悢łB

	\[Xf[^x[X𗘗p鑤͎̃t@CrhɊ܂݂܂B
		CRcDb.cpp
		CRcDb.h
		RcDbMessages.h

	sakura_rc_1033.dllsakura.exeƓtH_ɂ܂B


	̃RpĈ߂̏
		mc.exe -v -A RcDbMessages.mc
		rc -r RcDbMessages_1033.rc		//RcDbMessages.rcgȂ͕̂svȌ܂߂Ȃ߂ł
		link -dll -noentry -out:sakura_rc_1033.dll RcDbMessages_1033.res
*/

#include "stdafx.h"
#include <windows.h>
#include <map>
#include <vector>
#include <string.h>
#include <tchar.h>

#define RCDB_LANG_DEFAULT      ((LCID)1041)	//!< default language (Japanese)
#define RCDB_LANG_NAME_DEFAULT _T("Japanese")
#define RCDB_DLL_NAME          _T("sakura_rc_%d.dll")
#define RCDB_DLL_NAME_FIND     _T("sakura_rc_*.dll")
#define RCDB_LANG_PREFIX       _T("Sakura-Editor,")
#define RCDB_IDS_LANG          9999

/*
	Format:
		"New,New(&N),,,"
		"Show/Hide Tool Bar,Hide Tool Bar(&T),Show Tool Bar(&T),Hide Tool Bar(&?),Show Tool Bar(&?)"
*/
typedef enum rcdb_type_e {
	RCDB_TYPE_DEFAULT         = 0,
	RCDB_TYPE_MENU_ENABLE     = 1,
	RCDB_TYPE_MENU_DISABLE    = 2,
	RCDB_TYPE_MENU_ENABLE_SC  = 3,
	RCDB_TYPE_MENU_DISABLE_SC = 4,
	RCDB_TYPE_STRING          = RCDB_TYPE_DEFAULT,
	RCDB_TYPE_MENU            = RCDB_TYPE_MENU_ENABLE,
	RCDB_TYPE_MENU_SC         = RCDB_TYPE_MENU_ENABLE_SC,
	RCDB_TYPE_MENU_SHOW       = RCDB_TYPE_MENU_ENABLE,
	RCDB_TYPE_MENU_HIDE       = RCDB_TYPE_MENU_DISABLE,
	RCDB_TYPE_MENU_SHOW_SC    = RCDB_TYPE_MENU_ENABLE_SC,
	RCDB_TYPE_MENU_HIDE_SC    = RCDB_TYPE_MENU_DISABLE_SC,
	RCDB_TYPE_MENU_MAX
} ERcDbType;

typedef struct rcdb_item_t {
	LPTSTR	m_lpFile;
	LCID	m_lcId;
	LPTSTR	m_lpName;
} RcDbItem;
typedef std::vector < RcDbItem* > RcDbList;

/*
	shortcut macro
*/
#define RCDB_GetRcDbInstance()               ( CRcDb::GetInstance()->GetRcDbInstance() )
#define RCDB_LoadMenu( lpMenuName )          ( CRcDb::GetInstance()->LoadMenu( lpMenuName ) )
#define RCDB_LoadBitmap( lpBitmapString )    ( CRcDb::GetInstance()->LoadBitmap( lpBitmapString ) )
#define RCDB_LoadAccelerators( lpTableName ) ( CRcDb::GetInstance()->LoadAccelerators( lpTableName ) )
#define RCDB_LoadCursor( lpCursorName )      ( CRcDb::GetInstance()->LoadCursor( lpCursorName ) )
#define RCDB_LoadIcon( lpIconName )          ( CRcDb::GetInstance()->LoadIcon( lpIconName ) )
#define RCDB_LoadResource( lpResourceName, lpResourceType ) ( CRcDb::GetInstance()->LoadResource( lpResourceName, lpResourceType ) )
#define RCDB_LoadImage( lpImageName, uType, cxDesired, cyDesired, fuLoad ) ( CRcDb::GetInstance()->LoadImage( lpImageName, uType, cxDesired, cyDesired, fuLoad ) )
#define RCDB_LoadString( uID, lpBuffer, cchMaxBuffer ) ( CRcDb::GetInstance()->LoadString( uID, lpBuffer, cchMaxBuffer ) )
#define RCDB_GetString( uID )                ( CRcDb::GetInstance()->GetString( uID ) )
#define RCDB_GetMenuString( uID, eRcDbType ) ( CRcDb::GetInstance()->GetMenuString( uID, eRcDbType ) )
#define RCDB_GetMenuStringSC( uID, eRcDbType, chShortCut )  ( CRcDb::GetInstance()->GetMenuString( uID, eRcDbType, chShortCut ) )
#define RCDB_GetMenuDefaultString( uID )     ( CRcDb::GetInstance()->GetMenuString( uID ) )
#define RCDB_GetMenuEnableString( uID )      ( CRcDb::GetInstance()->GetMenuString( uID, RCDB_TYPE_MENU_ENABLE ) )
#define RCDB_GetMenuDisableString( uID )     ( CRcDb::GetInstance()->GetMenuString( uID, RCDB_TYPE_MENU_DISABLE ) )
#define RCDB_GetMenuEnableStringSC( uID, chShortCut )  ( CRcDb::GetInstance()->GetMenuString( uID, RCDB_TYPE_MENU_ENABLE, chShortCut ) )
#define RCDB_GetMenuDisableStringSC( uID, chShortCut ) ( CRcDb::GetInstance()->GetMenuString( uID, RCDB_TYPE_MENU_DISABLE, chShortCut ) )
#define RCDB_GetFormatMessage CRcDb::GetInstance()->GetFormatMessage

class CRcDb
{
private:
	static CRcDb*	m_lpRcDbThis;	//!< this
	LCID			m_uLangID;		//!< Lang ID
	HINSTANCE		m_hRcDb;		//!< Resource Database

	typedef struct rcdb_str_t {
		LPTSTR	m_lpMember[ 5 ];	//default, enable, disable, enable(shortcut), disable(shortcut)
	} RcDbStr;
	typedef std::pair < UINT, RcDbStr* >	PairRcDb;
	typedef std::map < UINT, RcDbStr* >	MapRcDbStr;
	MapRcDbStr	m_mapString;
	typedef std::pair < UINT, LPTSTR >	PairFmtMsg;
	typedef std::map < UINT, LPTSTR >	MapFmtMsg;
	MapFmtMsg	m_mapFmtMsg;

public:
	CRcDb(){
		//m_lpRcDbThis = NULL;
		m_uLangID = 0;
		m_hRcDb = NULL;
	}

	virtual ~CRcDb(){
		CloseRcDb();
	}

public:
	static CRcDb* GetInstance( void ){
		return m_lpRcDbThis;
	}

	bool Initialize( LCID uLangID = 0 ){
		if( NULL == m_lpRcDbThis ){
			m_lpRcDbThis = this;
		}
		if( m_uLangID != uLangID ){
			OpenRcDb( uLangID );
		}
		return true;
	}

	bool OpenRcDb( LCID uLangID = 0 );
	void CloseRcDb( void );

	HINSTANCE GetRcDbInstance( void ){
		return ( NULL == m_hRcDb ) ? ::GetModuleHandle( NULL ) : m_hRcDb;
	}

	HMENU LoadMenu( LPCTSTR lpMenuName ){
		return ::LoadMenu( CRcDb::GetRcDbInstance(), lpMenuName );
	}

	HBITMAP LoadBitmap( LPCTSTR lpBitmapString ){
		return ::LoadBitmap( CRcDb::GetRcDbInstance(), lpBitmapString );
	}

	HACCEL LoadAccelerators( LPCTSTR lpTableName ){
		return ::LoadAccelerators( CRcDb::GetRcDbInstance(), lpTableName );
	}

	HCURSOR LoadCursor( LPCTSTR lpCursorName ){
		return ::LoadCursor( CRcDb::GetRcDbInstance(), lpCursorName );
	}

	HICON LoadIcon( LPCTSTR lpIconName ){
		return ::LoadIcon( CRcDb::GetRcDbInstance(), lpIconName );
	}

	HRSRC FindResource( LPCTSTR lpResourceName, LPCTSTR lpResourceType ){
		return ::FindResource( CRcDb::GetRcDbInstance(), lpResourceName, lpResourceType );
	}

	HGLOBAL LoadResource( HRSRC hRsrc ){
		return ::LoadResource( CRcDb::GetRcDbInstance(), hRsrc );
	}

	HGLOBAL LoadResource( LPCTSTR lpResourceName, LPCTSTR lpResourceType ){
		HRSRC hRsrc = FindResource( lpResourceName, lpResourceType );
		if( NULL == hRsrc ) return NULL;
		return LoadResource( hRsrc );
	}

	HANDLE LoadImage( LPCTSTR lpImageName, UINT uType, int cxDesired, int cyDesired, UINT fuLoad ){
		return ::LoadImage( CRcDb::GetRcDbInstance(), lpImageName, uType, cxDesired, cyDesired, fuLoad );
	}

	int LoadString( UINT uID, LPTSTR lpBuffer, int cchMaxBuffer ){
		return ::LoadString( CRcDb::GetRcDbInstance(), uID, lpBuffer, cchMaxBuffer );
	}

	LPCTSTR GetString( UINT uID );
	LPCTSTR GetMenuString( UINT uID, ERcDbType eRcDbType = RCDB_TYPE_DEFAULT, TCHAR chShortCut = 0 );
	LPCTSTR GetFormatMessage( DWORD dwID, ... );

protected:
	RcDbStr* FindString( UINT uID );
	RcDbStr* CacheString( UINT uID );
	void SplitString( RcDbStr* lpRcDbStr );
	LPTSTR MakeShortCut( LPTSTR lpStr, TCHAR chShortCut );
	void RemoveAllString( void );
	int LoadRcDbList( RcDbList& rcDbList );
	void FreeRcDbList( RcDbList& rcDbList );
	void RemoveFmtMsg( DWORD dwID );
	void RemoveAllFmtMsg( void );
	LPCTSTR MakeRcDbPath( LPTSTR lpDst, LPCTSTR lpSrc );
};

#endif	//CRCDB_H
